
class customized_callbacks = object(self)
  inherit Blabla_my_callbacks.customized_callbacks
end




let main () =
  Arg.parse
    [("-u",
      Arg.String (fun username -> Global.user := username),
      "Specify the default player's name.")]      
    (fun filename ->
      try
	    let dic_file = open_in_bin filename in
	    let initial_base = ((input_value dic_file) : int) in
	    let dictionary = ((input_value dic_file) : Common.dictionary) in
	    close_in dic_file ;
	    Global.dictionary := Some dictionary ;
	    Global.initial_base := initial_base ;
	    (* On initialise les prferences courantes avec le dictionnaire. *)
	    Global.current_prefs.Global.dictionary_filename <- filename ;
	  with _ -> ())
    ("The Blabla's game. (c) Franois Pessaux 2004.") ;
  Random.self_init () ;
  ignore (Global.load_highscores ()) ;
  let callbacks = new customized_callbacks in
  let play_window = new Blabla_glade_interface.top_play_window callbacks in
  callbacks#set_play_window play_window ;
  (* Rajout  la main de la clist de solutions car non gre par MlGlade. *)
  let solutions_clist =
    GList.clist_poly
      ~packing: (play_window#solutions_scrolledwindow#add_with_viewport) () in
  solutions_clist#set_selection_mode `SINGLE ;
  Global.solutions_clist := Some solutions_clist ;
  (* Rajout de la valeur de l'indicateur de progression  la main. *)
  callbacks#top_play_window#elapsed_progressbar#set_show_text true ;
  (* On initialise la pixmap de status par dfaut. *)
  play_window#status_pixmap#set_pixmap Global.sleepy_pixmap ;
  ignore (play_window#play_window#show ()) ;
  GMain.Main.main ()
;;



try main () with Sys_error msg -> Printf.fprintf stderr "Error : %s\n" msg ;;
