let in_filename = ref "" ;;
let out_filename = ref "dico.out" ;;


let main () =
  Arg.parse
    [("-o", Arg.String (fun s -> out_filename := s),
      "Specify output dictionary file name") ]
    (fun fname -> in_filename := fname)
    "Create a dictionary from a sorted list of words" ;
  let dictionary = {
    Common.size = 500 ;
    Common.elements = Array.create 500 Int32.zero } in
  let in_file = open_in !in_filename in
  let initial_state = Table.make_dictionary in_file dictionary in
  close_in in_file ;
  let out_file = open_out_bin !out_filename in
  output_value out_file (initial_state : int) ;
  output_value out_file (dictionary : Common.dictionary) ;
  close_out out_file
;;


try main () with Sys_error msg -> Printf.fprintf stderr "Error : %s\n" msg ;;
