
let exists dictionary initial_base word =
  let word_len = String.length word in
  let dic_size = dictionary.Common.size in
  let dic_buckets = dictionary.Common.elements in

  let rec rec_exists base index_word =
    let current_letter = Char.code word.[index_word] in
    (* We ensure that we don't run outside the dictionary. *)
    if base + current_letter >= dic_size then false
    else
      let bucket = dic_buckets.(base + current_letter) in
      let tmp_char = Common.get_char bucket in
      (* We check that the cell is really used (useless in fact I think). *)
      if tmp_char = 0 then false
      else
        (* We check if there exists a transition on the character of the
           word. *)
        if tmp_char <> current_letter then false
        else
          (* If we are at the end of the word, we must verify that it
             corresponds to a real word of the dictionary. *)
          if index_word = word_len - 1 then
            if Common.is_final bucket then true else false
          else
            (* Otherwise, we must go on walking along the word. *)
            rec_exists (Common.get_next_base bucket) (index_word + 1) in

  if word = "" then false else rec_exists initial_base 0
;;
