(**
   Splits  a string into a list of strings according to the - and '
   characters. *)
let split_string string =
  let str_len = String.length string in
  let rec rec_split last_start index =
    if index >= str_len then
      [ String.sub string last_start (index - last_start) ]
    else
      if string.[index] = '\'' || string.[index] = '-' then
        let subs = String.sub string last_start (index - last_start) in
        subs :: rec_split (index + 1) (index + 1)
      else rec_split last_start (index + 1) in
  rec_split 0 0
;;
