let dic_name = ref "" ;;
let raw_mode = ref false ;;
let bin_mode = ref false ;;
let out_name = ref "" ;;

let main () =
  Arg.parse
    [("-r", Arg.Unit (fun _ -> raw_mode := true),
      "Dump the dictionary in raw format") ;
     ("-b", Arg.String (fun on -> out_name := on ; bin_mode := true),
      "Dump the dictionary in binary format")]
    (fun fname -> dic_name := fname)
    "Dump a dictionary" ;
  let dic_file = open_in_bin !dic_name in
  let initial_base = ((input_value dic_file) : int)  in
  let dictionary = ((input_value dic_file) : Common.dictionary) in
  close_in dic_file ;
  if !raw_mode then Printtable.raw_dump dictionary initial_base
  else Printtable.display_dictionary dictionary initial_base ;
  if !bin_mode then
    Printtable.raw_binary_dump dictionary initial_base !out_name
;;


try main () with Sys_error msg -> Printf.fprintf stderr "Error : %s\n" msg ;;
